select
    ultpar.data as ultimo_parto,
    an.numero as numero,
    (case when (ultpar.data is not null and priapp.data is not null) then (priapp.data - ultpar.data) else null end) as intervalo_prim_ia_e_parto,
    (case when ((current_date - cat.data)<=45 and cat.cdtiporeproducao = 7) then 'PEV' when (cat.cdtiporeproducao = 7 and (current_date - cat.data) > 45) then 'Vazia'
            when (cat.diagnostico = 'N') then 'Vazia' when (cat.diagnostico = 'P') then 'Gestante' when (cat.cdtiporeproducao = 1) then 'Inseminada' when
            (cat.cdtiporeproducao = 2) then 'Coberta' when (cat.cdtiporeproducao = 3) then 'Implantada' when (cat.cdtiporeproducao = 4 and cio in (1,2)) then
            'Vazia' else 'Vazia' end) as status_reprodutivo,
    (case sp.tipo
        when 1 then 'Doadora'
        when 2 then 'Receptora'
        when 3 then 'Descarte'
        else null end) as periodo_primeira_cob
from
    animal an
    left join reproducao ultpar on ultpar.cdreproducao =
            (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7 order by re.data desc)
    left join tipoparto tpultpar on tpultpar.cdtipoparto = ultpar.cdtipoparto
    left join reproducao priapp on priapp.cdreproducao =
            (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3) and re.data >
                    (coalesce (ultpar.data, '1900-01-01')) order by re.data)
    left join tiporeproducao tppriapp on tppriapp.cdtiporeproducao = priapp.cdtiporeproducao
    left join reproducao ultia on ultia.cdreproducao =
            (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3) order by re.data desc)
    left join reproducao cat on cat.cdreproducao =
            (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and (re.cdtiporeproducao in (1,2,3,7) or
            (re.cdtiporeproducao = 4 and (re.diagnostico is not null) or (re.cio is not null))) order by re.data desc)
    left join sp_animalperiodoespecifico(an.cdanimal, priapp.data) sp on 1 = 1
where
    an.tipoanimal = 'A' and
    an.dtbaixa is null and
    an.animalrebanho = '1' and
    an.sexo = 'F' and
    an.cdcategoria = 7 and
    priapp.data is not null and
---- NA PRXIMA LINHA, INFORME O PERODO DE OCORRNCIA DOS PARTOS NO FORMATO AAAA-MM-DD
    ultpar.data between '2015-01-01' and '2015-12-31'
order by
    priapp.data
